%define buildgnome 1
%define buildkde 1
%define desktop_file 1

%if %{desktop_file}
%define desktop_file_utils_version 0.2.93
%endif

Name: licq
Version: 1.2.7
Release: 3.ker.rhel3
Summary: An ICQ clone for online messaging.
License: GPL
Group: Applications/Communications
URL: http://www.licq.org/
Source: http://www.licq.org/licq-%{version}.tar.bz2
%if %{buildgnome}
Source2: licq-1.2.3-jons-gtk-gui.tar.bz2
%endif
Patch2: licq-conf.diff
Patch10: licq-1.2.3-libdir.patch
Patch11: licq-1.2.3-jons-gtk-gui-licq126.patch
Patch20: licq-1.2.7-gcc34.patch
BuildRoot: %{_tmppath}/%{name}-%{version}
BuildPrereq: libtool, XFree86-devel, libmng-devel, automake
Conflicts: licq-data < 1.6
BuildRequires: qt-devel >= 3.0.3 aspell-devel XFree86-devel ncurses-devel openssl-devel pkgconfig
%if %{buildgnome}
BuildRequires: gtk+-devel >= 1.2.0
%endif
%if %{buildkde}
BuildRequires: kdelibs-devel >= 3.0.0
%endif
# gcc 3.1-1 had a bug preventing this from compiling on alpha
BuildRequires: gcc >= 3.1-2
Requires: htmlview
%if %{desktop_file}
Requires: /usr/bin/desktop-file-install
BuildPrereq: desktop-file-utils >= %{desktop_file_utils_version}
%endif

%description
Licq is an ICQ online messaging system clone, written in C++ using the
Qt widget set. Licq supports all of the major features of ICQ,
including messaging, URLs, chat, file transfer, and user information.
Additionally, Licq is very configurable and supports skins and
different icon packs.

%package kde
Summary: KDE frontend for licq.
Provides: licq-frontend
Requires: %{name} = %{version}
Group: Applications/Communications

%description kde
Licq is an ICQ online messaging system clone.
Licq supports all of the major features of ICQ, including messaging, URLs,
chat, file transfer, and user information.

Licq-kde is a KDE frontend for licq.

%{name}-kde is a KDE frontend for licq.

%package gnome
Summary: GNOME frontend for licq.
Provides: licq-frontend
Requires: %{name} = %{version}
Group: Applications/Communications

%description gnome
Licq is an ICQ online messaging system clone.
Licq supports all of the major features of ICQ, including messaging, URLs,
chat, file transfer, and user information.

Licq-gnome is a GNOME frontend for licq.

%{name}-gnome is a GNOME frontend for licq.

%package qt
Summary: Qt frontend for licq.
Provides: licq-frontend
Requires: %{name} = %{version}
Group: Applications/Communications

%description qt
Licq is an ICQ online messaging system clone. Licq supports all of
the major features of ICQ, including messaging, URLs, chat, file
transfer, and user information.

Licq-qt is a graphical frontend for licq, written in Qt.

%{name}-qt is a graphical frontend for licq, written in Qt.

%package text
Summary: Text mode frontend for licq.
Provides: licq-frontend
Requires: %{name} = %{version}
Group: Applications/Communications

%description text
Licq is an ICQ online messaging system clone. Licq supports all of
the major features of ICQ, including messaging, URLs, chat, file
transfer, and user information.

Licq-text is a text mode frontend for licq.

%{name}-text is a text mode frontend for licq.

%prep
%setup -q -T -b 0
%if %{buildgnome}
%setup -q -T -b 0 -a 2
%endif
%patch2 -p1 -b .conf
%patch10 -p1 -b .libdir
%if %{buildgnome}
%patch11 -p1 -b .licq126
%endif
%patch20 -p1 -b .gcc34

%build
TOPDIR=`pwd`
export KDEDIR=%{_prefix}
unset QTDIR || : ; . /etc/profile.d/qt.sh
[ -e Makefile.cvs ] && make -f Makefile.cvs
./configure --prefix=%{_prefix} --libdir=%{_libdir} --datadir=%{_datadir}
for i in plugins/*; do
  if [ -d $i -a "$i" != "plugins/CVS" ]; then
    ( cd $i;
      [ -e configure ] || make -f Makefile.cvs
%if %{buildkde}
      ./configure --prefix=%{_prefix} --libdir=%{_libdir} --datadir=%{_datadir} --with-qt=$QTDIR --with-licq-includes=$TOPDIR/include --with-kde
%else
      ./configure --prefix=%{_prefix} --libdir=%{_libdir} --datadir=%{_datadir} --with-qt=$QTDIR --with-licq-includes=$TOPDIR/include --without-kde
%endif
      perl -pi -e 's|hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=\"-L\\\$libdir\"|g;' libtool
    )
  fi
done
make 
for i in plugins/*; do
  if echo $i |grep -q gtk; then
    continue
  fi
  if [ -d $i -a "$i" != "plugins/CVS" ]; then
    cd $i
    make 
    cd ../..
  fi
done
%if %{buildkde}
# Hack: build the Qt GUI plugin again. We need it both with and without KDE
# support.
cd plugins/qt-gui

if [ -f src/.libs/licq_kde-gui.so ]; then
cp src/.libs/licq_kde-gui.la ../
cp src/.libs/licq_kde-gui.so ../
else
cp src/.libs/licq_qt-gui.la ../licq_kde-gui.la 
cp src/.libs/licq_qt-gui.so ../licq_kde-gui.so
fi

rm -rf config.cache src/*.lo src/.libs/*.o autom4te.cache
./configure --prefix=%{_prefix} --libdir=%{_libdir} --datadir=%{_datadir} --with-qt=$QTDIR --with-licq-includes=$TOPDIR/include
perl -pi -e 's|hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=\"-L\\\$libdir\"|g;' libtool
make 
%endif

%install
export PATH=`pwd`:$PATH
rm -rf $RPM_BUILD_ROOT
export KDEDIR=$RPM_BUILD_ROOT%{_prefix}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applnk
%makeinstall plugindir="$RPM_BUILD_ROOT%{_libdir}/licq" sharedir="$RPM_BUILD_ROOT%{_prefix}/share/licq" incdir="$RPM_BUILD_ROOT%{_prefix}/include/licq"
for i in plugins/*; do
  if [ -d $i -a "$i" != "plugins/CVS" ]; then
    if echo $i |grep qt-gui; then # the Qt GUI Makefiles are BROKEN!
      make -C $i prefix="$RPM_BUILD_ROOT%{_prefix}" sharedir="$RPM_BUILD_ROOT%{_prefix}/share/licq" plugindir="$RPM_BUILD_ROOT%{_libdir}/licq" libdir=$RPM_BUILD_ROOT%{_libdir}/licq install
    else
      make -C $i DESTDIR="$RPM_BUILD_ROOT" sharedir="$RPM_BUILD_ROOT/%{_prefix}/share/licq" plugindir="$RPM_BUILD_ROOT%{_libdir}/licq" GTKGUI_DIR="$RPM_BUILD_ROOT%{_prefix}/share/licq/gtk-gui" libdir=%{_libdir}/licq install
    fi
  fi
done
( cd plugins
  for i in *; do
    if [ -d $i/doc ]; then
      cp -a $i/doc ../doc/$i
    else
      mkdir ../doc/$i
    fi
    for j in $i/README*; do
      cp -f $j ../doc/$i
    done
  done
)
%if %{buildkde}
install -c -m755 plugins/licq_kde-gui.la $RPM_BUILD_ROOT%{_libdir}/licq
install -c -m755 plugins/licq_kde-gui.so $RPM_BUILD_ROOT%{_libdir}/licq
%endif

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/X11
mv $KDEDIR/share/applnk $RPM_BUILD_ROOT%{_sysconfdir}/X11
mv $RPM_BUILD_ROOT%{_bindir}/licq $RPM_BUILD_ROOT%{_libdir}/licq/licq-bin

chmod 0755 $RPM_BUILD_ROOT%{_datadir}/licq
chmod 0755 $RPM_BUILD_ROOT%{_datadir}/licq/qt-gui
chmod 0755 $RPM_BUILD_ROOT%{_datadir}/licq/qt-gui/*

cat >$RPM_BUILD_ROOT%{_bindir}/licq <<EOF
#!/bin/sh
PARAMETERS="\$*"
FRONTENDS_TEXT="console"
FRONTENDS_KDE="kde-gui qt-gui console jons-gtk-gui"
FRONTENDS_GNOME="jons-gtk-gui qt-gui console kde-gui"
FRONTENDS_X11="qt-gui console kde-gui jons-gtk-gui"
if ! echo \$PARAMETERS | grep "\-p"; then
	FRONTEND=""
	if [ -z "\$DISPLAY" ]; then
		FRONTENDS=\$FRONTENDS_TEXT
	elif ps auxwww |grep -q kde\\init; then
		FRONTENDS=\$FRONTENDS_KDE
	elif ps auxwww |grep -q gnome-\\session; then
		FRONTENDS=\$FRONTENDS_GNOME
	else
		FRONTENDS=\$FRONTENDS_X11
	fi
	for i in \$FRONTENDS; do
		if [ -e %{_libdir}/licq/licq_\$i.so ]; then
			FRONTEND=\$i
			break
		fi
	done
	if [ -z "\$FRONTEND" ]; then
		echo "No appropriate frontend plugin found."
		exit 1
	fi
	PARAMETERS="\$PARAMETERS -p \$FRONTEND"
fi
exec %{_libdir}/licq/licq-bin \$PARAMETERS
EOF
chmod 0755 $RPM_BUILD_ROOT%{_bindir}/licq
%if %{desktop_file}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
desktop-file-install --vendor net \
        --dir $RPM_BUILD_ROOT%{_datadir}/applications \
        --add-category "Application;Network;X-Red-Hat-Extra" \
        $RPM_BUILD_ROOT%{_sysconfdir}/X11/applnk/Internet/licq.desktop
%endif

# remove files from the buildroot that we haven't/aren't shipping
rm -rf $RPM_BUILD_ROOT%{_sysconfdir}
rm -f $RPM_BUILD_ROOT%{_bindir}/{viewurl-lynx.sh,viewurl-ncftp.sh,viewurl-netscape.sh,viewurl-w3m.sh}
rm -rf $RPM_BUILD_ROOT%{_includedir}

%clean
rm -rf $RPM_BUILD_ROOT

%files 
%defattr (-,root,root)
%doc doc/*
%doc upgrade/*
%doc README*
%if %{desktop_file}
%{_datadir}/applications/*
%else
%{_sysconfdir}/X11/applnk/Internet/*
%endif
%attr(755,root,root) %{_bindir}/licq
%{_bindir}/viewurl-mozilla.sh
%{_bindir}/viewurl-opera.sh
%dir %{_libdir}/licq
%{_libdir}/licq/licq-bin
%{_libdir}/licq/licq_autoreply*
%{_libdir}/licq/licq_forwarder*
%{_libdir}/licq/licq_rms*
%{_datadir}/licq

%files qt
%defattr(-,root,root)
%{_libdir}/licq/licq_qt-gui*

%if %{buildkde}
%files kde
%defattr(-,root,root)
%{_libdir}/licq/licq_kde-gui*
%endif

%if %{buildgnome}
%files gnome
%defattr(-,root,root)
%{_libdir}/licq/licq_jons-gtk-gui*
%endif

%files text
%defattr(-,root,root)
%{_libdir}/licq/licq_console*

%changelog
* Wed May 26 2004 Milan Kerslager <kerslage@linux.cz> 1.2.7-3.ker.rhel3
- rebuild for RHEL3 (package from FC2)

* Tue Mar 30 2004 Harald Hoyer <harald@redhat.com> - 1.2.7-3
- fixed gcc34 compilation issues

* Tue Mar 02 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Mon Dec  1 2003 Thomas Woerner <twoerner@redhat.com> 1.2.7-1
- new version 1.2.7
- removed rpath

* Wed Jun 25 2003 Thomas Woerner <twoerner@redhat.com> 1.2.6-1
- new version 1.2.6
- cleanup spec file, patches

* Wed Jun 25 2003 Than Ngo <than@redhat.com> 1.2.3-9
- rebuilt

* Mon Feb 24 2003 Thomas Woerner <twoerner@redhat.com> 1.2.3-6
- fixed wrong libdir (/usr/lib) on 64 bit architectures

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Mon Jan 20 2003 Thomas Woerner <twoerner@redhat.com> 1.2.3-4
- fixed #70677

* Thu Jan 16 2003 Thomas Woerner <twoerner@redhat.com> 1.2.3-3
- fixed #77186

* Wed Jan 15 2003 Thomas Woerner <twoerner@redhat.com> 1.2.3-2
- fixed missing kde plugin

* Tue Jan 14 2003 Thomas Woerner <twoerner@redhat.com> 1.2.3-1
- 1.2.3

* Mon Jan  6 2003 Nalin Dahyabhai <nalin@redhat.com> 1.2.0a-6
- Add openssl-devel and pkgconfig as build-time requirements.
- Add flags from openssl's pkgconfig information to the build.
- Pass all flags to make as well as configure.

* Tue Dec 10 2002 Phil Knirsch <pknirsch@redhat.com> 1.2.0a-5
- Fixed wrong time_t usage.

* Wed Nov 27 2002 Than Ngo <than@redhat.com> 1.2.0a-4
- fix to build on x86_64

* Tue Nov 26 2002 Tim Powers <timp@redhat.com> 1.2.0a-3
- lib64'ize
- remove unpackaged files from the buildroot
- use rpm macros to define where files land (don't hardcode prefix in
  the specfile)

* Mon Aug 12 2002 Tim Powers <timp@redhat.com> 1.2.0a-2
- rebuilt with gcc-3.2

* Mon Jul 29 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.2.0a-1
- 1.2.0a

* Thu Jul 25 2002 Karsten Hopp <karsten@redhat.de>
- use desktop-file-utils

* Tue Jul 23 2002 Tim Powers <timp@redhat.com>
- build using gcc-3.2-0.1

* Thu Jul 11 2002 Karsten Hopp <karsten@redhat.de>
- fix #68512
  - write project file for lrelease
  - convert qt .po files into .ts (qt3 style)
  - use lrelease to write .qm files
  - rewrite po/Makefile
- fix typo in CFLAGS
- move make from %%setup to %%build

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Sun May 26 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Tue May 21 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.0-0.cvs20020521.1
- Build with current toolchain and update
- Temporarily remove the gnome frontend (until it's ported to the new libcapplet)
- Temporarily exclude alpha (compiler bug)

* Tue Apr 16 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.0-0.cvs20020416.1
- Build with current KDE

* Fri Apr 12 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.0-0.cvs20020412.1
- Update

* Wed Mar 27 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.0.4-3
- Don't crash on startup (#61924)

* Tue Mar 12 2002 Bill Nottingham <notting@redhat.com> 1.0.4-2
- tweak 1.0.4 package into compiling in current env.

* Fri Jan 18 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.0.4-1
- Update to 1.0.4
- Fix bug #55057
- Fix build with gcc 3.1
- Port KDE and Qt frontends to KDE/Qt 3.x
- Temporarily disable the gnome UI subpackage until buildroot issues
  are resolved

* Tue Aug 14 2001 Bernhard Rosenkraenzer <bero@redhat.com> 1.0.3-7
- Fix build with current libtool (#51570)

* Wed Jul 11 2001 Bernhard Rosenkraenzer <bero@redhat.com> 1.0.3-6
- Fix translations (#48471)

* Wed Jun 27 2001 Than Ngo <than@redhat.com> 1.0.3-5
- add patch to build on s390x
- fix package dependency

* Sun Jun 25 2001 Than Ngo <than@redhat.com> 1.0.3-4
- rebuild in new enviroment
- add Buildprereq
- use %%{_tmppath}

* Mon Apr 30 2001 Bernhard Rosenkraenzer <bero@redhat.com> 1.0.3-2
- Fix path to wav files (Bug #38308)

* Tue Apr 24 2001 Bernhard Rosenkraenzer <bero@redhat.com> 1.0.3-1
- licq 1.0.3
- licq-gtk+ 0.51.1
- Split the frontends into separate packages. Having one package depending
  on kde, gnome and ncurses is overkill.

* Fri Mar  2 2001 Nalin Dahyabhai <nalin@redhat.com>
- rebuild in new environment

* Wed Feb 28 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix 2 security issues:
  - buffer overrun in log.cpp
  - usage of system() to call up a browser without checking
    the URL (think of URL="' ; rm -rf ~/ ; '")

* Mon Dec 25 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 1.0.2

* Thu Oct 12 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 1.0
- Get rid of the -O0 hack, gcc has been fixed

* Wed Aug 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix crashes when setting an away message

* Wed Aug 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Use -O0 for compiling the plugins - the current compiler "optimizes"
  some Qt objects to endless loops

* Tue Aug 22 2000 Tim Powers <timp@redhat.com>
- fix location of sounds, translations, and utilities. This was the core of
  the problem in bug #16409 (which is fixed with this)

* Sun Aug  6 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 0.85
- gtk plugin 0.39
- fix compilation with gcc 2.96
- Exclude ia64 until the compiler gets fixed

* Mon Jul 31 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Get rid of world-writable files (Bug #14911)
- stop using egcs

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Tue Jul  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- rebuild with kernelcc, or we'll get nasty conflicts with different
  libstdc++ versions.

* Mon Jun 19 2000 Karsten Hopp <karsten@redhat.de>
- rebuild with new db

* Sat Jun 17 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 0.84b
- fix several bugs
- fix build with gcc 2.96
- fix build without a previously installed copy
- work around compiler bugs on IA64

* Tue Jun  6 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- initial build in main distribution
- fix up the gtk+ plugin to work with gcc 2.96
- some hacks to make it work with %%configure
- fix build on ia64

* Sat Jun  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 0.84a
- work around several compiler breakages
- get rid of wmconfig stuff, move desktop file to /etc/X11/applnk
- disable gtk GUI for now (doesn't compile with 0.84a)

* Tue May 30 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 0.81
- Qt 2.1.1
- fix up the config patch to deal with the new licq-data layout
- conflict with older licq-data packages; they're no longer usable.
- some random fixes
- add the gtk frontend from gtk.licq.org

* Fri Feb 18 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 0.76
- remove %post
- rebuild with Qt 2.1.0-beta1
- enable console plugin, add a script to automatically detect whether or not
  we need to use it.

* Mon Feb  7 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 0.75.3a (some bugfixes)

* Wed Jan 26 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 0.75.3
- some spec file cleanups

* Sun Jan  9 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix build on Alpha

* Sun Jan  9 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Use Qt 2.1.0, the version we're actually shipping

* Wed Nov 17 1999 Tim Powers <timp@redhat.com>
- moved configure portions to %build section, shouldn't be before that
- explicitely use qt-2.0.1 in configure
- rebuilt for Powertools
- export QTDIR

* Fri Nov 12 1999 Graham Roff <graham@licq.org>
- Upgraded to 0.71

* Thu Oct 28 1999 Graham Roff <graham@licq.org>
- fixed requirement to qt 2.0.2

* Mon Oct 25 1999 Graham Roff <graham@licq.org>
- modified for new distribution format
- upgraded to 0.70.1

* Mon Aug 30 1999 Tim Powers <timp@redhat.com>
- changed group

* Mon Jul 19 1999 Tim Powers <timp@redhat.com>
- moved changelog to bottom
- using contrib|net spec now
- changed buildroot to /var/tmp
- rebuilt and put into powertools

* Wed Jun 18 1999 Alexey Nogin <ayn2@cornell.edu>
[licq-0.70f-1]
- Upgraded to licq-0.70f with licq_qt-gui-0.64.1
- Updated URLs
- Added localization files

* Fri Mar 12 1999 Alexey Nogin <ayn2@cornell.edu>
[licq-0.61-1]
- Fixed Auto Away - Auto N/A problem.

* Tue Mar  9 1999 Alexey Nogin <ayn2@cornell.edu>
[licq-0.61-1]
- Incorporated numerous small changes inspired
by Graham Roff's (Licq author) version of the spec file

* Mon Feb 22 1999 Alexey Nogin <ayn2@cornell.edu>
[licq-0.60-1]
- Added viewurl-*.sh to /usr/bin/

* Mon Dec 14 1998 Alexey Nogin <ayn2@cornell.edu>
[licq-0.50-alpha-2]
- Updated the URL

* Fri Dec 11 1998 Alexey Nogin <ayn2@cornell.edu>
[licq-0.50-alpha-1]
- Added SPEC file %defattr directive to enable non-root builds
- Changed SPEC file according to RHCN rules.

* Fri Oct 30 1998  Ian Macdonald <ianmacd@xs4all.nl>
- Upgraded to 0.44
